<html>
<head>
<title>OgreTexture.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreTexture.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreTexture_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef _Texture_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define _Texture_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwareBuffer_8h.html">OgreHardwareBuffer.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreResource_8h.html">OgreResource.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreImage_8h.html">OgreImage.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre {
<a name="l00037"></a>00037 
<a name="l00046"></a><a class="code" href="group__Resources.html#gaf140ec886884a864abc74a7556f8bf67">00046</a>     <span class="keyword">enum</span> <a class="code" href="group__Resources.html#gaf140ec886884a864abc74a7556f8bf67" title="Enum identifying the texture usage.">TextureUsage</a>
<a name="l00047"></a>00047     {
<a name="l00049"></a><a class="code" href="group__Resources.html#ggaf140ec886884a864abc74a7556f8bf67a375858a86cadfb2a4d20fe837fdb85b3">00049</a>         <a class="code" href="group__Resources.html#ggaf140ec886884a864abc74a7556f8bf67a375858a86cadfb2a4d20fe837fdb85b3">TU_STATIC</a> = <a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630a6f26f67ab31d60248314c9c6c77c9edb" title="Static buffer which the application rarely modifies once created.">HardwareBuffer::HBU_STATIC</a>,
<a name="l00050"></a><a class="code" href="group__Resources.html#ggaf140ec886884a864abc74a7556f8bf67ad18031f12c4bd22f73b09a4536e99df5">00050</a>         <a class="code" href="group__Resources.html#ggaf140ec886884a864abc74a7556f8bf67ad18031f12c4bd22f73b09a4536e99df5">TU_DYNAMIC</a> = <a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630abec61c14b13652a06566a79afd6f7518" title="Indicates the application would like to modify this buffer with the CPU fairly often.">HardwareBuffer::HBU_DYNAMIC</a>,
<a name="l00051"></a><a class="code" href="group__Resources.html#ggaf140ec886884a864abc74a7556f8bf67af7b0d53154ffc7c389404dc51c792655">00051</a>         <a class="code" href="group__Resources.html#ggaf140ec886884a864abc74a7556f8bf67af7b0d53154ffc7c389404dc51c792655">TU_WRITE_ONLY</a> = <a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630a2fe20ff00e9acb928a2d9680f0c505e2" title="Indicates the application will never read the contents of the buffer back, it will only ever write da...">HardwareBuffer::HBU_WRITE_ONLY</a>,
<a name="l00052"></a><a class="code" href="group__Resources.html#ggaf140ec886884a864abc74a7556f8bf67a2b9d0399c32f2098957ebc089c337e55">00052</a>         <a class="code" href="group__Resources.html#ggaf140ec886884a864abc74a7556f8bf67a2b9d0399c32f2098957ebc089c337e55">TU_STATIC_WRITE_ONLY</a> = <a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630a5ffbb339becd31435c5f616be4c28996" title="Combination of HBU_STATIC and HBU_WRITE_ONLY.">HardwareBuffer::HBU_STATIC_WRITE_ONLY</a>, 
<a name="l00053"></a><a class="code" href="group__Resources.html#ggaf140ec886884a864abc74a7556f8bf67ac26eda030d21e0491461edea89394493">00053</a>         <a class="code" href="group__Resources.html#ggaf140ec886884a864abc74a7556f8bf67ac26eda030d21e0491461edea89394493">TU_DYNAMIC_WRITE_ONLY</a> = <a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630aa0c82d1b27d6cc04e4b5f6d47a22a74c" title="Combination of HBU_DYNAMIC and HBU_WRITE_ONLY.">HardwareBuffer::HBU_DYNAMIC_WRITE_ONLY</a>,
<a name="l00054"></a><a class="code" href="group__Resources.html#ggaf140ec886884a864abc74a7556f8bf67a79920182637c94fabcf834950096483f">00054</a>         <a class="code" href="group__Resources.html#ggaf140ec886884a864abc74a7556f8bf67a79920182637c94fabcf834950096483f">TU_DYNAMIC_WRITE_ONLY_DISCARDABLE</a> = <a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630a29ff2e0fd2b408359e84291b27282516" title="Combination of HBU_DYNAMIC, HBU_WRITE_ONLY and HBU_DISCARDABLE.">HardwareBuffer::HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE</a>,
<a name="l00056"></a><a class="code" href="group__Resources.html#ggaf140ec886884a864abc74a7556f8bf67a7c14cc95a59af42a63eb33fc9de05d27">00056</a>         <a class="code" href="group__Resources.html#ggaf140ec886884a864abc74a7556f8bf67a7c14cc95a59af42a63eb33fc9de05d27" title="mipmaps will be automatically generated for this texture">TU_AUTOMIPMAP</a> = 0x100,
<a name="l00059"></a><a class="code" href="group__Resources.html#ggaf140ec886884a864abc74a7556f8bf67ae1661d9846a9b4e83c2e4cd99fc6ad9d">00059</a>         <a class="code" href="group__Resources.html#ggaf140ec886884a864abc74a7556f8bf67ae1661d9846a9b4e83c2e4cd99fc6ad9d" title="this texture will be a render target, i.e.">TU_RENDERTARGET</a> = 0x200,
<a name="l00061"></a><a class="code" href="group__Resources.html#ggaf140ec886884a864abc74a7556f8bf67acaa45fe77d1becf4c5bd353bc2aa764b">00061</a>         <a class="code" href="group__Resources.html#ggaf140ec886884a864abc74a7556f8bf67acaa45fe77d1becf4c5bd353bc2aa764b" title="default to automatic mipmap generation static textures">TU_DEFAULT</a> = <a class="code" href="group__Resources.html#ggaf140ec886884a864abc74a7556f8bf67a7c14cc95a59af42a63eb33fc9de05d27" title="mipmaps will be automatically generated for this texture">TU_AUTOMIPMAP</a> | <a class="code" href="group__Resources.html#ggaf140ec886884a864abc74a7556f8bf67a2b9d0399c32f2098957ebc089c337e55">TU_STATIC_WRITE_ONLY</a>
<a name="l00062"></a>00062         
<a name="l00063"></a>00063     };
<a name="l00064"></a>00064 
<a name="l00067"></a><a class="code" href="group__Resources.html#gae50520af6377ff8184cf79125cb9c4d7">00067</a>     <span class="keyword">enum</span> <a class="code" href="group__Resources.html#gae50520af6377ff8184cf79125cb9c4d7" title="Enum identifying the texture type.">TextureType</a>
<a name="l00068"></a>00068     {
<a name="l00070"></a><a class="code" href="group__Resources.html#ggae50520af6377ff8184cf79125cb9c4d7a18bf88d3a14ba28d6602689e398416bd">00070</a>         <a class="code" href="group__Resources.html#ggae50520af6377ff8184cf79125cb9c4d7a18bf88d3a14ba28d6602689e398416bd" title="1D texture, used in combination with 1D texture coordinates">TEX_TYPE_1D</a> = 1,
<a name="l00072"></a><a class="code" href="group__Resources.html#ggae50520af6377ff8184cf79125cb9c4d7af1f732018f5a2a7d35233e2ceeb4ee0e">00072</a>         <a class="code" href="group__Resources.html#ggae50520af6377ff8184cf79125cb9c4d7af1f732018f5a2a7d35233e2ceeb4ee0e" title="2D texture, used in combination with 2D texture coordinates (default)">TEX_TYPE_2D</a> = 2,
<a name="l00074"></a><a class="code" href="group__Resources.html#ggae50520af6377ff8184cf79125cb9c4d7aa80e2545e817591a0b4547f987987d43">00074</a>         <a class="code" href="group__Resources.html#ggae50520af6377ff8184cf79125cb9c4d7aa80e2545e817591a0b4547f987987d43" title="3D volume texture, used in combination with 3D texture coordinates">TEX_TYPE_3D</a> = 3,
<a name="l00076"></a><a class="code" href="group__Resources.html#ggae50520af6377ff8184cf79125cb9c4d7ae295fe0fa26623b66cc023f462962344">00076</a>         <a class="code" href="group__Resources.html#ggae50520af6377ff8184cf79125cb9c4d7ae295fe0fa26623b66cc023f462962344" title="3D cube map, used in combination with 3D texture coordinates">TEX_TYPE_CUBE_MAP</a> = 4,
<a name="l00078"></a><a class="code" href="group__Resources.html#ggae50520af6377ff8184cf79125cb9c4d7a11589b2d4fbe6213dcdaf4e78894a3a7">00078</a>         <a class="code" href="group__Resources.html#ggae50520af6377ff8184cf79125cb9c4d7a11589b2d4fbe6213dcdaf4e78894a3a7" title="2D texture array">TEX_TYPE_2D_ARRAY</a> = 5
<a name="l00079"></a>00079     };
<a name="l00080"></a>00080 
<a name="l00083"></a><a class="code" href="group__Resources.html#ga528ce4f4c67c9b043e1f0b8bb3cdf255">00083</a>     <span class="keyword">enum</span> <a class="code" href="group__Resources.html#ga528ce4f4c67c9b043e1f0b8bb3cdf255" title="Enum identifying special mipmap numbers.">TextureMipmap</a>
<a name="l00084"></a>00084     {
<a name="l00086"></a><a class="code" href="group__Resources.html#gga528ce4f4c67c9b043e1f0b8bb3cdf255a5a6b498127bf3fa219dadfdaaa50b9dd">00086</a>         <a class="code" href="group__Resources.html#gga528ce4f4c67c9b043e1f0b8bb3cdf255a5a6b498127bf3fa219dadfdaaa50b9dd" title="Generate mipmaps up to 1x1.">MIP_UNLIMITED</a> = 0x7FFFFFFF,
<a name="l00088"></a><a class="code" href="group__Resources.html#gga528ce4f4c67c9b043e1f0b8bb3cdf255a56eea45719de5246f4ea9b8e8b54921d">00088</a>         <a class="code" href="group__Resources.html#gga528ce4f4c67c9b043e1f0b8bb3cdf255a56eea45719de5246f4ea9b8e8b54921d" title="Use TextureManager default.">MIP_DEFAULT</a> = -1
<a name="l00089"></a>00089     };
<a name="l00090"></a>00090 
<a name="l00091"></a>00091     <span class="comment">// Forward declaration</span>
<a name="l00092"></a>00092     <span class="keyword">class </span>TexturePtr;
<a name="l00093"></a>00093 
<a name="l00103"></a><a class="code" href="classOgre_1_1Texture.html">00103</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Texture.html" title="Abstract class representing a Texture resource.">Texture</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Resource.html" title="Abstract class representing a loadable resource (e.g.">Resource</a>
<a name="l00104"></a>00104     {
<a name="l00105"></a>00105     <span class="keyword">public</span>:
<a name="l00106"></a>00106         <a class="code" href="classOgre_1_1Texture.html" title="Abstract class representing a Texture resource.">Texture</a>(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* creator, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle,
<a name="l00107"></a>00107             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual = <span class="keyword">false</span>, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader = 0);
<a name="l00108"></a>00108 
<a name="l00111"></a><a class="code" href="classOgre_1_1Texture.html#a99ab7ce9aba371bab2f04fe1eebe6f26">00111</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Texture.html#a99ab7ce9aba371bab2f04fe1eebe6f26" title="Sets the type of texture; can only be changed before load()">setTextureType</a>(<a class="code" href="group__Resources.html#gae50520af6377ff8184cf79125cb9c4d7" title="Enum identifying the texture type.">TextureType</a> ttype ) { mTextureType = ttype; }
<a name="l00112"></a>00112 
<a name="l00115"></a><a class="code" href="classOgre_1_1Texture.html#a3db3e97f86e298f79fd09e511f572cc1">00115</a>         <span class="keyword">virtual</span> <a class="code" href="group__Resources.html#gae50520af6377ff8184cf79125cb9c4d7" title="Enum identifying the texture type.">TextureType</a> <a class="code" href="classOgre_1_1Texture.html#a3db3e97f86e298f79fd09e511f572cc1" title="Gets the type of texture.">getTextureType</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mTextureType; }
<a name="l00116"></a>00116 
<a name="l00119"></a><a class="code" href="classOgre_1_1Texture.html#a73913a082bfc8f1e3de44441df92308a">00119</a>         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1Texture.html#a73913a082bfc8f1e3de44441df92308a" title="Gets the number of mipmaps to be used for this texture.">getNumMipmaps</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{<span class="keywordflow">return</span> mNumMipmaps;}
<a name="l00120"></a>00120 
<a name="l00125"></a><a class="code" href="classOgre_1_1Texture.html#a3cd584d5e1b9bbd1eb665303f9fca7ee">00125</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Texture.html#a3cd584d5e1b9bbd1eb665303f9fca7ee" title="Sets the number of mipmaps to be used for this texture.">setNumMipmaps</a>(<span class="keywordtype">size_t</span> num) {mNumRequestedMipmaps = mNumMipmaps = num;}
<a name="l00126"></a>00126 
<a name="l00131"></a><a class="code" href="classOgre_1_1Texture.html#a3435f815f90fdf90e3c28393125e3168">00131</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Texture.html#a3435f815f90fdf90e3c28393125e3168" title="Are mipmaps hardware generated?">getMipmapsHardwareGenerated</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mMipmapsHardwareGenerated; }
<a name="l00132"></a>00132 
<a name="l00135"></a><a class="code" href="classOgre_1_1Texture.html#aae8fa69ad2ea0d4b84c85d280197953b">00135</a>         <span class="keyword">virtual</span> <span class="keywordtype">float</span> <a class="code" href="classOgre_1_1Texture.html#aae8fa69ad2ea0d4b84c85d280197953b" title="Returns the gamma adjustment factor applied to this texture on loading.">getGamma</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mGamma; }
<a name="l00136"></a>00136 
<a name="l00145"></a><a class="code" href="classOgre_1_1Texture.html#a34a2cf25885b2d6f16adc1dbd7275e09">00145</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Texture.html#a34a2cf25885b2d6f16adc1dbd7275e09" title="Sets the gamma adjustment factor applied to this texture on loading the data.">setGamma</a>(<span class="keywordtype">float</span> g) { mGamma = g; }
<a name="l00146"></a>00146 
<a name="l00165"></a><a class="code" href="classOgre_1_1Texture.html#a41e0ef825d3ce3c305d1b4d34103da13">00165</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Texture.html#a41e0ef825d3ce3c305d1b4d34103da13" title="Sets whether this texture will be set up so that on sampling it, hardware gamma correction is applied...">setHardwareGammaEnabled</a>(<span class="keywordtype">bool</span> enabled) { mHwGamma = enabled; }
<a name="l00166"></a>00166 
<a name="l00170"></a><a class="code" href="classOgre_1_1Texture.html#ae41a45cc2461c263936f620708b08976">00170</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Texture.html#ae41a45cc2461c263936f620708b08976" title="Gets whether this texture will be set up so that on sampling it, hardware gamma correction is applied...">isHardwareGammaEnabled</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mHwGamma; }
<a name="l00171"></a>00171 
<a name="l00179"></a><a class="code" href="classOgre_1_1Texture.html#ab930e26d3531e20604e22e3324759ad4">00179</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Texture.html#ab930e26d3531e20604e22e3324759ad4" title="Set the level of multisample AA to be used if this texture is a rendertarget.">setFSAA</a>(<a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> fsaa, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; fsaaHint) { mFSAA = fsaa; mFSAAHint = fsaaHint; }
<a name="l00180"></a>00180 
<a name="l00184"></a><a class="code" href="classOgre_1_1Texture.html#aa9336fcb9283afad0259466633533f33">00184</a>         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> <a class="code" href="classOgre_1_1Texture.html#aa9336fcb9283afad0259466633533f33" title="Get the level of multisample AA to be used if this texture is a rendertarget.">getFSAA</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mFSAA; }
<a name="l00185"></a>00185 
<a name="l00188"></a><a class="code" href="classOgre_1_1Texture.html#a78a1bb99cc419187c77141ab05edb7ea">00188</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="code" href="classOgre_1_1Texture.html#a78a1bb99cc419187c77141ab05edb7ea" title="Get the multisample AA hint if this texture is a rendertarget.">getFSAAHint</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mFSAAHint; }
<a name="l00189"></a>00189 
<a name="l00192"></a><a class="code" href="classOgre_1_1Texture.html#a487fd460a132f1c4097ec1f6d2e7c37c">00192</a>         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1Texture.html#a487fd460a132f1c4097ec1f6d2e7c37c" title="Returns the height of the texture.">getHeight</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mHeight; }
<a name="l00193"></a>00193 
<a name="l00196"></a><a class="code" href="classOgre_1_1Texture.html#a68051f56bb8d87ce19640a8026586207">00196</a>         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1Texture.html#a68051f56bb8d87ce19640a8026586207" title="Returns the width of the texture.">getWidth</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mWidth; }
<a name="l00197"></a>00197 
<a name="l00200"></a><a class="code" href="classOgre_1_1Texture.html#a08698c8524b74c8303927f665f36e827">00200</a>         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1Texture.html#a08698c8524b74c8303927f665f36e827" title="Returns the depth of the texture (only applicable for 3D textures).">getDepth</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mDepth; }
<a name="l00201"></a>00201 
<a name="l00204"></a><a class="code" href="classOgre_1_1Texture.html#a772f4bd16b6b629f16f112926be4d460">00204</a>         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1Texture.html#a772f4bd16b6b629f16f112926be4d460" title="Returns the height of the original input texture (may differ due to hardware requirements).">getSrcHeight</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSrcHeight; }
<a name="l00205"></a>00205 
<a name="l00208"></a><a class="code" href="classOgre_1_1Texture.html#a8637d1b6b0c6b17c10dbe0bc65ce8dc4">00208</a>         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1Texture.html#a8637d1b6b0c6b17c10dbe0bc65ce8dc4" title="Returns the width of the original input texture (may differ due to hardware requirements).">getSrcWidth</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSrcWidth; }
<a name="l00209"></a>00209 
<a name="l00212"></a><a class="code" href="classOgre_1_1Texture.html#a9037f86414b57597677ea98d66c40001">00212</a>         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1Texture.html#a9037f86414b57597677ea98d66c40001" title="Returns the original depth of the input texture (only applicable for 3D textures).">getSrcDepth</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mSrcDepth; }
<a name="l00213"></a>00213 
<a name="l00216"></a><a class="code" href="classOgre_1_1Texture.html#ab4f95c16ba72153a00a3422289099296">00216</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Texture.html#ab4f95c16ba72153a00a3422289099296" title="Set the height of the texture; can only do this before load();.">setHeight</a>(<span class="keywordtype">size_t</span> h) { mHeight = mSrcHeight = h; }
<a name="l00217"></a>00217 
<a name="l00220"></a><a class="code" href="classOgre_1_1Texture.html#ab966147d746a969aa80a0ae71d6fb0e2">00220</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Texture.html#ab966147d746a969aa80a0ae71d6fb0e2" title="Set the width of the texture; can only do this before load();.">setWidth</a>(<span class="keywordtype">size_t</span> w) { mWidth = mSrcWidth = w; }
<a name="l00221"></a>00221 
<a name="l00225"></a><a class="code" href="classOgre_1_1Texture.html#afd7eb62399bd48b21f6763eba94ab28d">00225</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Texture.html#afd7eb62399bd48b21f6763eba94ab28d" title="Set the depth of the texture (only applicable for 3D textures); can only do this before load();...">setDepth</a>(<span class="keywordtype">size_t</span> d)  { mDepth = mSrcDepth = d; }
<a name="l00226"></a>00226 
<a name="l00229"></a><a class="code" href="classOgre_1_1Texture.html#a5544f33879e292ff3d0c6fb13129ba0d">00229</a>         <span class="keyword">virtual</span> <span class="keywordtype">int</span> getUsage()<span class="keyword"> const</span>
<a name="l00230"></a>00230 <span class="keyword">        </span>{
<a name="l00231"></a>00231             <span class="keywordflow">return</span> mUsage;
<a name="l00232"></a>00232         }
<a name="l00233"></a>00233 
<a name="l00241"></a><a class="code" href="classOgre_1_1Texture.html#a04969ca1d25bf40e71e907f2cdb7443b">00241</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Texture.html#a04969ca1d25bf40e71e907f2cdb7443b" title="Sets the TextureUsage identifier for this Texture; only useful before load()">setUsage</a>(<span class="keywordtype">int</span> u) { mUsage = u; }
<a name="l00242"></a>00242 
<a name="l00254"></a>00254         <span class="keyword">virtual</span> <span class="keywordtype">void</span> createInternalResources(<span class="keywordtype">void</span>);
<a name="l00255"></a>00255 
<a name="l00258"></a>00258         <span class="keyword">virtual</span> <span class="keywordtype">void</span> freeInternalResources(<span class="keywordtype">void</span>);
<a name="l00259"></a>00259         
<a name="l00262"></a>00262         <span class="keyword">virtual</span> <span class="keywordtype">void</span> copyToTexture( <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a>&amp; target );
<a name="l00263"></a>00263 
<a name="l00270"></a>00270         <span class="keyword">virtual</span> <span class="keywordtype">void</span> loadImage( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Image.html" title="Class representing an image file.">Image</a> &amp;img );
<a name="l00271"></a>00271             
<a name="l00282"></a>00282         <span class="keyword">virtual</span> <span class="keywordtype">void</span> loadRawData( <a class="code" href="classOgre_1_1SharedPtr.html">DataStreamPtr</a>&amp; stream, 
<a name="l00283"></a>00283             <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> uWidth, <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> uHeight, <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> eFormat);
<a name="l00284"></a>00284 
<a name="l00290"></a>00290         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _loadImages( <span class="keyword">const</span> <a class="code" href="group__Image.html#gad3242b650f2562b87c992002a18c395f">ConstImagePtrList</a>&amp; images );
<a name="l00291"></a>00291 
<a name="l00293"></a><a class="code" href="classOgre_1_1Texture.html#a91a5ec6b7cae49a1f7aa05b7beac966b">00293</a>         <span class="keyword">virtual</span> <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> getFormat()<span class="keyword"> const</span>
<a name="l00294"></a>00294 <span class="keyword">        </span>{
<a name="l00295"></a>00295             <span class="keywordflow">return</span> mFormat;
<a name="l00296"></a>00296         }
<a name="l00297"></a>00297 
<a name="l00299"></a><a class="code" href="classOgre_1_1Texture.html#a01e66834e5af4ac5d24222d24c09a9ca">00299</a>         <span class="keyword">virtual</span> <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> getDesiredFormat(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00300"></a>00300 <span class="keyword">        </span>{
<a name="l00301"></a>00301             <span class="keywordflow">return</span> mDesiredFormat;
<a name="l00302"></a>00302         }
<a name="l00303"></a>00303 
<a name="l00307"></a><a class="code" href="classOgre_1_1Texture.html#ad4dccbd257ef80d031b4d9e72ca08164">00307</a>         <span class="keyword">virtual</span> <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> getSrcFormat(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00308"></a>00308 <span class="keyword">        </span>{
<a name="l00309"></a>00309             <span class="keywordflow">return</span> mSrcFormat;
<a name="l00310"></a>00310         }
<a name="l00311"></a>00311 
<a name="l00313"></a>00313         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setFormat(<a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> pf);
<a name="l00314"></a>00314 
<a name="l00316"></a>00316         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> hasAlpha(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00317"></a>00317 
<a name="l00323"></a>00323         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setDesiredIntegerBitDepth(<a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> bits);
<a name="l00324"></a>00324 
<a name="l00327"></a>00327         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> getDesiredIntegerBitDepth(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00328"></a>00328 
<a name="l00334"></a>00334         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setDesiredFloatBitDepth(<a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> bits);
<a name="l00335"></a>00335 
<a name="l00338"></a>00338         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> getDesiredFloatBitDepth(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00339"></a>00339 
<a name="l00342"></a>00342         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setDesiredBitDepths(<a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> integerBits, <a class="code" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> floatBits);
<a name="l00343"></a>00343 
<a name="l00346"></a>00346         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setTreatLuminanceAsAlpha(<span class="keywordtype">bool</span> asAlpha);
<a name="l00347"></a>00347 
<a name="l00350"></a>00350         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> getTreatLuminanceAsAlpha(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00351"></a>00351 
<a name="l00355"></a>00355         <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> getNumFaces() <span class="keyword">const</span>;
<a name="l00356"></a>00356 
<a name="l00369"></a>00369         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1HardwarePixelBufferSharedPtr.html" title="Shared pointer implementation used to share pixel buffers.">HardwarePixelBufferSharedPtr</a> getBuffer(<span class="keywordtype">size_t</span> face=0, <span class="keywordtype">size_t</span> mipmap=0) = 0;
<a name="l00370"></a>00370 
<a name="l00371"></a>00371 
<a name="l00376"></a>00376         <span class="keyword">virtual</span> <span class="keywordtype">void</span> convertToImage(<a class="code" href="classOgre_1_1Image.html" title="Class representing an image file.">Image</a>&amp; destImage, <span class="keywordtype">bool</span> includeMipMaps = <span class="keyword">false</span>);
<a name="l00377"></a>00377         
<a name="l00383"></a><a class="code" href="classOgre_1_1Texture.html#accfa5467ab8ccfc5920ec64101f8f532">00383</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Texture.html#accfa5467ab8ccfc5920ec64101f8f532" title="Retrieve a platform or API-specific piece of information from this texture.">getCustomAttribute</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">void</span>* pData) {}
<a name="l00384"></a>00384         
<a name="l00385"></a>00385 
<a name="l00386"></a>00386 
<a name="l00387"></a>00387     <span class="keyword">protected</span>:
<a name="l00388"></a><a class="code" href="classOgre_1_1Texture.html#a05ffc612f2d228396455f429325d99d4">00388</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1Texture.html#a05ffc612f2d228396455f429325d99d4">mHeight</a>;
<a name="l00389"></a><a class="code" href="classOgre_1_1Texture.html#a1619297beb23828218b26ce18362a984">00389</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1Texture.html#a1619297beb23828218b26ce18362a984">mWidth</a>;
<a name="l00390"></a><a class="code" href="classOgre_1_1Texture.html#a55f60f21398b55836e13a692b90dd736">00390</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1Texture.html#a55f60f21398b55836e13a692b90dd736">mDepth</a>;
<a name="l00391"></a>00391 
<a name="l00392"></a><a class="code" href="classOgre_1_1Texture.html#a6958c92e9f0e66c4a3d132ed273ea319">00392</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1Texture.html#a6958c92e9f0e66c4a3d132ed273ea319">mNumRequestedMipmaps</a>;
<a name="l00393"></a><a class="code" href="classOgre_1_1Texture.html#a6b82c3ed419e91a11bd9d0063df83ed9">00393</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1Texture.html#a6b82c3ed419e91a11bd9d0063df83ed9">mNumMipmaps</a>;
<a name="l00394"></a><a class="code" href="classOgre_1_1Texture.html#a78c173eadbdbce6c766632a40fc0363c">00394</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Texture.html#a78c173eadbdbce6c766632a40fc0363c">mMipmapsHardwareGenerated</a>;
<a name="l00395"></a><a class="code" href="classOgre_1_1Texture.html#a91414bf8610084680cc21144c93e34ca">00395</a>         <span class="keywordtype">float</span> <a class="code" href="classOgre_1_1Texture.html#a91414bf8610084680cc21144c93e34ca">mGamma</a>;
<a name="l00396"></a><a class="code" href="classOgre_1_1Texture.html#a12c901db5fff58d9779f327bb363b088">00396</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Texture.html#a12c901db5fff58d9779f327bb363b088">mHwGamma</a>;
<a name="l00397"></a><a class="code" href="classOgre_1_1Texture.html#a74aefafbb9c481bf31e39996ef69458c">00397</a>         <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> <a class="code" href="classOgre_1_1Texture.html#a74aefafbb9c481bf31e39996ef69458c">mFSAA</a>;
<a name="l00398"></a><a class="code" href="classOgre_1_1Texture.html#a834e35614c75542a09e423cdd6b33bc8">00398</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1Texture.html#a834e35614c75542a09e423cdd6b33bc8">mFSAAHint</a>;
<a name="l00399"></a>00399 
<a name="l00400"></a><a class="code" href="classOgre_1_1Texture.html#aab3add1d83300d2518d4ae9864c32651">00400</a>         <a class="code" href="group__Resources.html#gae50520af6377ff8184cf79125cb9c4d7" title="Enum identifying the texture type.">TextureType</a> <a class="code" href="classOgre_1_1Texture.html#aab3add1d83300d2518d4ae9864c32651">mTextureType</a>;
<a name="l00401"></a><a class="code" href="classOgre_1_1Texture.html#a74872f190e8c6d2da750c03698ad73fd">00401</a>         <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> <a class="code" href="classOgre_1_1Texture.html#a74872f190e8c6d2da750c03698ad73fd">mFormat</a>;
<a name="l00402"></a><a class="code" href="classOgre_1_1Texture.html#ae3c39759ac6bea7faa7c60d3994927a4">00402</a>         <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1Texture.html#ae3c39759ac6bea7faa7c60d3994927a4">mUsage</a>; <span class="comment">// Bit field, so this can&#39;t be TextureUsage</span>
<a name="l00403"></a>00403 
<a name="l00404"></a><a class="code" href="classOgre_1_1Texture.html#a2598c4e24ba37ce5f82393be82aeddc6">00404</a>         <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> <a class="code" href="classOgre_1_1Texture.html#a2598c4e24ba37ce5f82393be82aeddc6">mSrcFormat</a>;
<a name="l00405"></a><a class="code" href="classOgre_1_1Texture.html#aa15877330d8c2ce5b6cf6715937f2b12">00405</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1Texture.html#aa15877330d8c2ce5b6cf6715937f2b12">mSrcWidth</a>, mSrcHeight, mSrcDepth;
<a name="l00406"></a>00406 
<a name="l00407"></a><a class="code" href="classOgre_1_1Texture.html#a4c9e046e633bacb741cbe2518dfbc649">00407</a>         <a class="code" href="group__Image.html#ga7e0353e7d36d4c2e8468641b7303d39c" title="The pixel format used for images, textures, and render surfaces.">PixelFormat</a> <a class="code" href="classOgre_1_1Texture.html#a4c9e046e633bacb741cbe2518dfbc649">mDesiredFormat</a>;
<a name="l00408"></a><a class="code" href="classOgre_1_1Texture.html#a1797d9ab733702d0c0b05ba3fd6f1584">00408</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code" href="classOgre_1_1Texture.html#a1797d9ab733702d0c0b05ba3fd6f1584">mDesiredIntegerBitDepth</a>;
<a name="l00409"></a><a class="code" href="classOgre_1_1Texture.html#aa06a0be1885e8ff96fde33277140e46f">00409</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code" href="classOgre_1_1Texture.html#aa06a0be1885e8ff96fde33277140e46f">mDesiredFloatBitDepth</a>;
<a name="l00410"></a><a class="code" href="classOgre_1_1Texture.html#aa922f905790cc650b2761caa2e28e51e">00410</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Texture.html#aa922f905790cc650b2761caa2e28e51e">mTreatLuminanceAsAlpha</a>;
<a name="l00411"></a>00411 
<a name="l00412"></a><a class="code" href="classOgre_1_1Texture.html#ae5bc056fc6cc83ae12cf2a3d0786e87b">00412</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1Texture.html#ae5bc056fc6cc83ae12cf2a3d0786e87b">mInternalResourcesCreated</a>;
<a name="l00413"></a>00413 
<a name="l00415"></a>00415         <span class="keywordtype">size_t</span> calculateSize(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00416"></a>00416         
<a name="l00417"></a>00417 
<a name="l00420"></a>00420         <span class="keyword">virtual</span> <span class="keywordtype">void</span> createInternalResourcesImpl(<span class="keywordtype">void</span>) = 0;
<a name="l00421"></a>00421 
<a name="l00424"></a>00424         <span class="keyword">virtual</span> <span class="keywordtype">void</span> freeInternalResourcesImpl(<span class="keywordtype">void</span>) = 0;
<a name="l00425"></a>00425 
<a name="l00427"></a>00427         <span class="keywordtype">void</span> unloadImpl(<span class="keywordtype">void</span>);
<a name="l00428"></a>00428 
<a name="l00432"></a>00432         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> getSourceFileType() <span class="keyword">const</span>;
<a name="l00433"></a>00433 
<a name="l00434"></a>00434     };
<a name="l00435"></a>00435 
<a name="l00442"></a><a class="code" href="classOgre_1_1TexturePtr.html">00442</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;Texture&gt; 
<a name="l00443"></a>00443     {
<a name="l00444"></a>00444     <span class="keyword">public</span>:
<a name="l00445"></a><a class="code" href="classOgre_1_1TexturePtr.html#a13754a294a53828f0e5a4c39900a96c0">00445</a>         <a class="code" href="classOgre_1_1TexturePtr.html#a13754a294a53828f0e5a4c39900a96c0">TexturePtr</a>() : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Texture.html" title="Abstract class representing a Texture resource.">Texture</a>&gt;() {}
<a name="l00446"></a><a class="code" href="classOgre_1_1TexturePtr.html#a4b1f2286b5b01581283f39a6c5e3ddea">00446</a>         <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1TexturePtr.html#a4b1f2286b5b01581283f39a6c5e3ddea">TexturePtr</a>(<a class="code" href="classOgre_1_1Texture.html" title="Abstract class representing a Texture resource.">Texture</a>* rep) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Texture.html" title="Abstract class representing a Texture resource.">Texture</a>&gt;(rep) {}
<a name="l00447"></a><a class="code" href="classOgre_1_1TexturePtr.html#a5223bb40c734e8307aea5970ea8ceedc">00447</a>         <a class="code" href="classOgre_1_1TexturePtr.html#a5223bb40c734e8307aea5970ea8ceedc">TexturePtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a>&amp; r) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Texture.html" title="Abstract class representing a Texture resource.">Texture</a>&gt;(r) {} 
<a name="l00448"></a><a class="code" href="classOgre_1_1TexturePtr.html#aa949c8217f4bdbd53b3071ce91dbce1f">00448</a>         <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; r) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1Texture.html" title="Abstract class representing a Texture resource.">Texture</a>&gt;()
<a name="l00449"></a>00449         {
<a name="l00450"></a>00450             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00451"></a>00451             <a class="code" href="OgrePrerequisites_8h.html#a2201eef4cf31a94b24d79de6de3445af">OGRE_MUTEX_CONDITIONAL</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00452"></a>00452             {
<a name="l00453"></a>00453                 <a class="code" href="OgrePrerequisites_8h.html#a8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00454"></a>00454                 <a class="code" href="OgrePrerequisites_8h.html#acf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00455"></a>00455                 pRep = <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1Texture.html" title="Abstract class representing a Texture resource.">Texture</a>*<span class="keyword">&gt;</span>(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>());
<a name="l00456"></a>00456                 pUseCount = r.<a class="code" href="classOgre_1_1SharedPtr.html#a21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>();
<a name="l00457"></a>00457                 <span class="keywordflow">if</span> (pUseCount)
<a name="l00458"></a>00458                 {
<a name="l00459"></a>00459                     ++(*pUseCount);
<a name="l00460"></a>00460                 }
<a name="l00461"></a>00461             }
<a name="l00462"></a>00462         }
<a name="l00463"></a>00463 
<a name="l00465"></a><a class="code" href="classOgre_1_1TexturePtr.html#a9c0d31e0de80559b9ba2749f96caff65">00465</a>         <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a>&amp; operator=(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; r)
<a name="l00466"></a>00466         {
<a name="l00467"></a>00467             <span class="keywordflow">if</span> (pRep == static_cast&lt;Texture*&gt;(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>()))
<a name="l00468"></a>00468                 <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00469"></a>00469             release();
<a name="l00470"></a>00470             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00471"></a>00471             <a class="code" href="OgrePrerequisites_8h.html#a2201eef4cf31a94b24d79de6de3445af">OGRE_MUTEX_CONDITIONAL</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00472"></a>00472             {
<a name="l00473"></a>00473                 <a class="code" href="OgrePrerequisites_8h.html#a8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00474"></a>00474                 <a class="code" href="OgrePrerequisites_8h.html#acf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00475"></a>00475                 pRep = <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1Texture.html" title="Abstract class representing a Texture resource.">Texture</a>*<span class="keyword">&gt;</span>(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>());
<a name="l00476"></a>00476                 pUseCount = r.<a class="code" href="classOgre_1_1SharedPtr.html#a21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>();
<a name="l00477"></a>00477                 <span class="keywordflow">if</span> (pUseCount)
<a name="l00478"></a>00478                 {
<a name="l00479"></a>00479                     ++(*pUseCount);
<a name="l00480"></a>00480                 }
<a name="l00481"></a>00481             }
<a name="l00482"></a>00482             <span class="keywordflow">else</span>
<a name="l00483"></a>00483             {
<a name="l00484"></a>00484                 <span class="comment">// RHS must be a null pointer</span>
<a name="l00485"></a>00485                 assert(r.<a class="code" href="classOgre_1_1SharedPtr.html#a8a223db784efd7aa766792649de2f2a0">isNull</a>() &amp;&amp; <span class="stringliteral">&quot;RHS must be null if it has no mutex!&quot;</span>);
<a name="l00486"></a>00486                 setNull();
<a name="l00487"></a>00487             }
<a name="l00488"></a>00488             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00489"></a>00489         }
<a name="l00490"></a>00490     };
<a name="l00494"></a>00494 }
<a name="l00495"></a>00495 
<a name="l00496"></a>00496 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
